import { Directive } from "@angular/core";
import { BREAKPOINT, ShowHideDirective, FlexDirective } from "@angular/flex-layout";

const XXS_BREAKPOINTS = [
    {
        alias: "xxs",
        mediaQuery: "screen and (max-width: 479px)",
        overlapping: false
    },
    {
        alias: "xs", // redéfinition
        mediaQuery: "screen and (min-width: 480px) screen and (max-width: 599px)",
        overlapping: false
    },
    {
        alias: "gt-xxs",
        mediaQuery: "screen and (min-width: 480px)",
        overlapping: false
    },
    {
        alias: "lt-xs",
        mediaQuery: "screen and (max-width: 479px)",
        overlapping: false
    }
];

export const CustomBreakPointsProvider = {
    provide: BREAKPOINT,
    useValue: XXS_BREAKPOINTS,
    multi: true
};

const inputsXxs = [ "fxHide.xxs" ];
const inputsGtXxs = [ "fxHide.gt-xxs" ];
const inputsLtXs = [ "fxHide.lt-xs" ];

@Directive({
    // tslint:disable-next-line:directive-selector
    selector: `[fxHide.xxs]`,
    // tslint:disable-next-line:use-input-property-decorator
    inputs: inputsXxs
})
export class FlexXxsShowHideDirective extends ShowHideDirective {
    protected inputs = inputsXxs;
}

@Directive({
    // tslint:disable-next-line:directive-selector
    selector: `[fxHide.gt-xxs]`,
    // tslint:disable-next-line:use-input-property-decorator
    inputs: inputsGtXxs
})
export class FlexGtXxsShowHideDirective extends ShowHideDirective {
    protected inputs = inputsGtXxs;
}

@Directive({
    // tslint:disable-next-line:directive-selector
    selector: `[fxHide.lt-xs]`,
    // tslint:disable-next-line:use-input-property-decorator
    inputs: inputsLtXs
})
export class FlexLtXsShowHideDirective extends ShowHideDirective {
    protected inputs = inputsLtXs;
}
